/*
 * Generic_Value methods tests
 * Testing Generic_Value methods
 *
 */ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tet_api.h>
#include <ft2build.h>
#include FT_FREETYPE_H
#include <fontconfig/fontconfig.h>
#define _XFT_NO_COMPAT
#define _XFTCOMPAT_H_
#include <X11/Xlib.h>
#include <X11/Xft/Xft.h>
#include <pango/pangoft2.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <gmodule.h>
#include <gdk/gdkkeysyms.h>
#include <errno.h>
#include <unistd.h>

#include "libtestgen.h"
#include "libstr.h"
#include "libfile.h"
#include "libthr.h"

#define TEST_FAIL(str, ...) {test_failed ();tet_printf("%s, line %d: ", __FILE__, __LINE__);tet_printf (str, __VA_ARGS__);}

/*
 * global variables
 */

int test_purp_passed_num = 0;
int all_test_purp_num = 0;
int double_bug = 0;
unsigned test_passed_flag = 1;

/*
 * function prototypes
 */
static char* get_not_created_msg (void);
static char* get_wrong_type_msg (void);
static void test_passed (void);
static void test_failed (void);
static void startup_func();
static void cleanup_func();


gchar* bug_inf = NULL;
static void test_interface_init(gpointer g_iface, gpointer iface_data)
{
    return;
}

#define TEST_TYPE   (test_get_type())
#define TEST(obj)   (G_TYPE_CHECK_INSTANCE_CAST((obj), TEST_TYPE, Test))

typedef struct _Test        Test;
typedef struct _TestClass   TestClass;

struct _Test {
    GObject parent;
};

struct _TestClass {
    GObjectClass parent_class;
};

GType test_get_type(void)
{
    static GType type = 0;
    if (!type){
        static GTypeInfo const type_info = {
            sizeof(TestClass),
            NULL, NULL,
            NULL, NULL,
            NULL,
            sizeof(Test),
            0,
            NULL
        };
        static const GInterfaceInfo interface_info = {
            (GInterfaceInitFunc)test_interface_init,
            NULL,
            NULL
        };
        type = g_type_register_static(G_TYPE_OBJECT, "Test_Object", &type_info, 0);
        g_type_add_interface_static(type, TEST_TYPE, &interface_info);
    }
    return type;
}

Test* test_new(void)
{
    Test* test = g_object_new(TEST_TYPE, NULL);
    
    return test;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_INVALID
 * Expected: G_TYPE_INVALID  
 */
static void test_purpose_1()
{
    #define VALUE_TYPE  G_TYPE_INVALID
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_NONE
 * Expected: G_TYPE_NONE  
 */
static void test_purpose_2()
{
    #define VALUE_TYPE  G_TYPE_NONE
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_INTERFACE
 * Expected: G_TYPE_INTERFACE  
 */
static void test_purpose_3()
{
    #define VALUE_TYPE  G_TYPE_INTERFACE
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_CHAR
 * Expected: G_TYPE_CHAR  
 */
static void test_purpose_4()
{
    #define VALUE_TYPE  G_TYPE_CHAR
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_UCHAR
 * Expected: G_TYPE_UCHAR  
 */
static void test_purpose_5()
{
    #define VALUE_TYPE  G_TYPE_UCHAR
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_BOOLEAN
 * Expected: G_TYPE_BOOLEAN  
 */
static void test_purpose_6()
{
    #define VALUE_TYPE  G_TYPE_BOOLEAN
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_INT
 * Expected: G_TYPE_INT  
 */
static void test_purpose_7()
{
    #define VALUE_TYPE  G_TYPE_INT
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_UINT
 * Expected: G_TYPE_UINT  
 */
static void test_purpose_8()
{
    #define VALUE_TYPE  G_TYPE_UINT
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_LONG
 * Expected: G_TYPE_LONG  
 */
static void test_purpose_9()
{
    #define VALUE_TYPE  G_TYPE_LONG
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_ULONG
 * Expected: G_TYPE_ULONG  
 */
static void test_purpose_10()
{
    #define VALUE_TYPE  G_TYPE_ULONG
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_INT64
 * Expected: G_TYPE_INT64  
 */
static void test_purpose_11()
{
    #define VALUE_TYPE  G_TYPE_INT64
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_UINT64
 * Expected: G_TYPE_UINT64  
 */
static void test_purpose_12()
{
    #define VALUE_TYPE  G_TYPE_UINT64
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_FLOAT
 * Expected: G_TYPE_FLOAT  
 */
static void test_purpose_13()
{
    #define VALUE_TYPE  G_TYPE_FLOAT
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_DOUBLE
 * Expected: G_TYPE_DOUBLE  
 */
static void test_purpose_14()
{
    #define VALUE_TYPE  G_TYPE_DOUBLE
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_STRING
 * Expected: G_TYPE_STRING  
 */
static void test_purpose_15()
{
    #define VALUE_TYPE  G_TYPE_STRING
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_POINTER
 * Expected: G_TYPE_POINTER  
 */
static void test_purpose_16()
{
    #define VALUE_TYPE  G_TYPE_POINTER
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_init
 * Params: GValue *value, GType g_type
 * Returns: GValue*
 * Assertion: Initializes value with the default value of type.
 *            value :  A zero-filled (uninitialized) GValue structure.
 *            g_type :    Type the GValue should hold values of.
 *            Returns :   the GValue structure that has been passed in
 * Params Values: G_TYPE_OBJECT
 * Expected: G_TYPE_OBJECT  
 */
static void test_purpose_17()
{
    #define VALUE_TYPE  G_TYPE_OBJECT
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue value = {0, };
    if (VALUE_TYPE == G_TYPE_INTERFACE){
        Test* test = test_new();
        g_value_init(&value, TEST_TYPE);
    }
    else{
        g_value_init(&value, VALUE_TYPE);
        if (VALUE_TYPE != G_TYPE_NONE){
            if (G_VALUE_TYPE(&value) != VALUE_TYPE){
                TEST_FAIL("g_value_init: %d", VALUE_TYPE);
            }
        }
    }
    
    #undef VALUE_TYPE
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_copy
 * Params: const GValue *src_value, GValue *dest_value
 * Returns: void
 * Assertion: Copies the value of src_value into dest_value.
 *            src_value :  An initialized GValue structure.
 *            dest_value :    An initialized GValue structure of the same type as src_value.
 * Params Values: const GValue *src_value, GValue *dest_value
 * Expected: void  
 */
static void test_purpose_18()
{
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue v_a = { 0, };
    GValue v_b = { 0, };
    
    g_value_init(&v_a, G_TYPE_INT);
    g_value_init(&v_b, G_TYPE_INT);
    
    g_value_set_int(&v_a, 10);
    g_value_copy(&v_a, &v_b);
    if (g_value_get_int(&v_b) != 10){
        TEST_FAIL("g_value_copy: failed", NULL);
    }
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_unset
 * Params: GValue *value
 * Returns: void
 * Assertion: Clears the current value in value and "unsets" the type, this releases all resources associated with this GValue. An unset value is the same as an uninitialized (zero-filled) GValue structure.
 *            value :   An initialized GValue structure.
 * Params Values: GValue *value
 * Expected: void  
 */
static void test_purpose_19()
{
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    GValue v_a = { 0, };
    g_value_init(&v_a, G_TYPE_INT);
    g_value_set_int(&v_a, 10);
    g_value_unset(&v_a);
    if (G_VALUE_TYPE(&v_a) != G_TYPE_INVALID){
        TEST_FAIL("g_value_unset: failed", NULL);
    }
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_peek_pointer
 * Params: const GValue *value
 * Returns: gpointer
 * Assertion: Return the value contents as pointer. This function asserts that g_value_fits_pointer() returned TRUE for the passed in value. This is an internal function introduced mainly for C marshallers.
 *            value :  An initialized GValue structure.
 *            Returns :   TRUE if value will fit inside a pointer value.
 * Params Values: const GValue *value
 * Expected: void  
 */
static void test_purpose_20()
{
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    gpointer rets;
    GValue v_a = { 0, };
    g_value_init(&v_a, G_TYPE_STRING);
    g_value_set_string(&v_a, "Hello");
    rets = g_value_peek_pointer(&v_a);
    if (strcmp((char *)rets, "Hello") != 0){
        TEST_FAIL("g_value_peek_pointer: failed", NULL);
    }
    
	
    test_passed ();

    double_bug = 0;
}

/*
 * Name: g_value_transform
 * Params: const GValue *src_value, GValue *dest_value
 * Returns: gboolean
 * Assertion: Tries to cast the contents of src_value into a type apropriate to store in dest_value, e.g. to transform a G_TYPE_INT value into a G_TYPE_FLOAT value. Performing transformations between value types might incour precision lossage. Especially transformations into strings might reveal seemingly arbitrary results and shouldn't be relied upon for production code (such as rcfile value or object property serialization).
 *            src_value :  Source value.
 *            dest_value :    Target value.
 *            Returns :   Whether a transformation rule was found and could be applied. Upon failing transformations, dest_value is left untouched.
 * Params Values: G_TYPE_UINT, 0xabcdef01, G_TYPE_UCHAR
 * Expected: TRUE, 0x01  
 */
static void test_purpose_21()
{
    #define SRC_TYPE    G_TYPE_UINT
    #define SRC_VAL     0xabcdef01
    #define DEST_TYPE   G_TYPE_UCHAR
    #define RET_BOOLEAN TRUE
    #define RET_VAL     0x01
    #define SET_VALUE   g_value_set_uint
    #define GET_VALUE   g_value_get_uchar
    

    bug_inf = NULL;
    test_passed_flag = 1;          
    all_test_purp_num++;
    fprintf (stderr, mark_symbol (all_test_purp_num));
    tet_printf("test case: %s, TP number: %d ", tet_pname, tet_thistest);

    gboolean retb;
    GValue v_a = { 0, };
    GValue v_b = { 0, };
    
    g_value_init(&v_a, SRC_TYPE);
    g_value_init(&v_b, DEST_TYPE);
    
    SET_VALUE(&v_a, SRC_VAL);
    retb = g_value_transform(&v_a, &v_b);
    if (retb != RET_BOOLEAN){
        TEST_FAIL("g_value_transform: failed", NULL);
    }
    else{
        if (GET_VALUE(&v_b) != RET_VAL){
            TEST_FAIL("g_value_transform: value now is %d", GET_VALUE(&v_b));
        }
    }
    #undef SRC_TYPE
    #undef SRC_VAL
    #undef DEST_TYPE
    #undef RET_BOOLEAN
    #undef RET_VAL
    #undef SET_VALUE
    #undef GET_VALUE
    
	
    test_passed ();

    double_bug = 0;
}


static 
char* get_not_created_msg (void)
{
        return "Widget is not created\n";
}

static 
char* get_wrong_type_msg (void)
{
        return "Created widget is of wrong type\n";
}


/*
 *  test_passed
 */
static void 
test_passed (void)
{
    if (bug_inf && !double_bug)
    {
	double_bug = 1;
    }

    if (test_passed_flag)
    {
        test_purp_passed_num++;
    }
    tet_result (TET_PASS);
}

/*
 *  test_failed
 */
static void
test_failed (void)
{
    if (bug_inf && !double_bug)
    {
	double_bug = 1;
    }

    test_passed_flag = 0;
    tet_result (TET_FAIL);
}

/*
 * startup_func
 * open display and initialize other per test case things
 */
static void 
startup_func()
{
    int argc = 1;
    char** argv = NULL;

    argv = calloc(argc,  sizeof(char*));
    argv[0] = (char*)strdup(""); 
    gtk_init(&argc, &argv);
    fprintf (stderr, "Function tests for Generic_Value ");
}
 
/*
 * cleanup_func
 */
static void 
cleanup_func()
{

    fprintf (stderr, " %d passed", test_purp_passed_num);
    if (all_test_purp_num != test_purp_passed_num)
    {
        fprintf (stderr, " %d FAILED", all_test_purp_num - test_purp_passed_num);        
    }
    fprintf (stderr, "\n"); 
}


/* 
 *Program hooks into the tet harness 
 */
void (*tet_startup)() = startup_func;
void (*tet_cleanup)() = cleanup_func;

/*
 * TET Tests included in this file. 
 */
struct tet_testlist tet_testlist[] = {
    {test_purpose_1, 1},
    {test_purpose_2, 1},
    {test_purpose_3, 1},
    {test_purpose_4, 1},
    {test_purpose_5, 1},
    {test_purpose_6, 1},
    {test_purpose_7, 1},
    {test_purpose_8, 1},
    {test_purpose_9, 1},
    {test_purpose_10, 1},
    {test_purpose_11, 1},
    {test_purpose_12, 1},
    {test_purpose_13, 1},
    {test_purpose_14, 1},
    {test_purpose_15, 1},
    {test_purpose_16, 1},
    {test_purpose_17, 1},
    {test_purpose_18, 1},
    {test_purpose_19, 1},
    {test_purpose_20, 1},
    {test_purpose_21, 1},
    {NULL,0}
};
